/*
    Copyright (C) 2001-2003 KSVG Team
    This file is part of the KDE project

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

// TODO: CLEANUP

#include <kdebug.h>
#include <math.h>
#include "SVGMatrixImpl.h"
#include "SVGDocumentImpl.h"
#include "SVGTextPathElement.h"
#include "SVGPathElementImpl.h"
#include "SVGTextPathElementImpl.h"
#include "SVGAnimatedStringImpl.h"
#include "SVGSVGElementImpl.h"
#include "SVGAnimatedEnumerationImpl.h"
#include "SVGAnimatedLengthImpl.h"
#include "KSVGCanvas.h"
#include "KSVGHelper.h"
#include "ksvg_ecma.h"

using namespace KSVG;

#include "ksvg_scriptinterpreter.h"
#include "SVGTextPathElementImpl.lut.h"

SVGTextPathElementImpl::SVGTextPathElementImpl(DOM::ElementImpl *impl) : SVGTextContentElementImpl(impl), SVGURIReferenceImpl()
{
	KSVG_EMPTY_FLAGS

	m_startOffset = new SVGAnimatedLengthImpl();
	m_startOffset->ref();

	m_method = new SVGAnimatedEnumerationImpl();
	m_method->ref();

	m_spacing = new SVGAnimatedEnumerationImpl();
	m_spacing->ref();

	m_percentage = false;
}

SVGTextPathElementImpl::~SVGTextPathElementImpl()
{
	if(m_startOffset)
		m_startOffset->deref();
	if(m_method)
		m_method->deref();
	if(m_spacing)
		m_spacing->deref();
}

SVGAnimatedLengthImpl *SVGTextPathElementImpl::startOffset() const
{
	return m_startOffset;
}

SVGAnimatedEnumerationImpl *SVGTextPathElementImpl::method() const
{
	return m_method;
}

SVGAnimatedEnumerationImpl *SVGTextPathElementImpl::spacing() const
{
	return m_spacing;
}

/*ArtBpath *SVGTextPathElementImpl::split(double, QPtrList<ArtBpath> &, unsigned int)
{
	ArtBpath *prev = (i > 1 ? data.at(i - 1) : 0);

	if(!prev || i == 0)
        return 0;

	// Beziers.
    KSVGPoint q[4];
    q[0] = KSVGPoint(prev->x3, prev->y3);
    q[1] = KSVGPoint(data.at(i)->x1, data.at(i)->y1);
    q[2] = KSVGPoint(data.at(i)->x2, data.at(i)->y2);
    q[3] = KSVGPoint(data.at(i)->x3, data.at(i)->y3);

	ArtBpath *bpath = art_new(ArtBpath, 1);
	

	// The De Casteljau algorithm.
	for(unsigned short j = 1; j <= 3; ++j)
	{
		for(unsigned short i = 0; i <= 3 - j; ++i)
			q[i] = (1.0 - t) * q[i] + t * q[i + 1];

		// Modify the new segment.
		if((j - 1) == 0)
		{
			bpath->x1 = q[0].x();
			bpath->y1 = q[0].y();
		}
		else if((j - 1) == 1)
		{
			bpath->x2 = q[0].x();
			bpath->x2 = q[0].y();
		}
		else if((j - 1) == 2)
		{
			bpath->x3 = q[0].x();
			bpath->x3 = q[0].y();
		}

//		segment->setPoint(j - 1, q[0]);
	}

	// Modify the current segment (no need to modify the knot though)
	ArtBpath *cur = data.at(i);

	for(unsigned short i = 1; i < 3; ++i)
	{
		if((i - 1) == 0)
		{
			cur->x1 = q[i].x();
			cur->y1 = q[i].y();
		}
		else if((i - 1) == 1)
		{
			cur->x2 = q[i].x();
			cur->x2 = q[i].y();
		}
		else if((i - 1) == 2)
		{
			cur->x3 = q[i].x();
			cur->x3 = q[i].y();
		}

//		setPoint( i - 1, q[ i ] );
	}

	return bpath;
	return 0;
}

double SVGTextPathElementImpl::chordLength(ArtBpath *current, ArtBpath *previous) const
{
	return sqrt((current->x3 - previous->x3) * (current->x3 - previous->x3) +
				(current->y3 - previous->y3) *	(current->y3 - previous->y3));
}

double SVGTextPathElementImpl::polyLength(ArtBpath *current, ArtBpath *previous) const
{
	return sqrt(
				(current->x1 - previous->x3) *
				(current->x1 - previous->x3) +
				(current->x1 - previous->x3) *
				(current->x1 - previous->x3)) +
		   sqrt(
				(current->x2 - current->x1) *
				(current->x2 - current->x1)	+
				(current->x2 - current->x1) *
				(current->x2 - current->x1)) +
		   sqrt(
				(current->x3 - current->x2) *
				(current->x3 - current->x2) +
				(current->x3 - current->x2) *
				(current->x3 - current->x2));
}
*/
/*double SVGTextPathElementImpl::length(ArtBpath *current, ArtBpath *previous)
{
}*/
/*
double SVGTextPathElementImpl::length(QPtrList<ArtBpath> &, unsigned int) const
{
	ArtBpath *prev = 0;
	
	for(unsigned int i = 0; i < data.count(); i++)
	{
	QPtrList<ArtBpath> temp;
	
	ArtBpath *first = art_new(ArtBpath, 1);
	first.x1 = first.y1 = first.x3 = first.y3 = 0.0;
	first.x2 = 
//	temp.x2 = 
	
	double length = 0.0;
	unsigned int i = 0;


	QPtrListIterator<ArtBpath> it(temp);
	while(it.current())
	{
		// Determine length of a bezier curve
		//
        // This algortihm is based on an idea by Jens Gravesen <gravesen@mat.dth.dk>.
        // We calculate the chord length "chord"=|P0P3| and the length of the control point
        // polygon "poly"=|P0P1|+|P1P2|+|P2P3|. The approximation for the bezier length is
        // 0.5 * poly + 0.5 * chord. "poly - chord" is a measure for the error.
        // We subdivide each segment until the error is smaller than a given tolerance
        // and add up the subresults.
		//
		// From the karbon team...

		double chord, poly;

		this->length(temp.current(), previous, chord, poly);

			if(poly && (poly - chord) / poly > 0.005)
			{
				
				// Split at midpoint.
//				path.insert(path.current()->splitAt(0.5));
	
				temp.append(
				ArtBpath *SVGTextPathElementImpl::split(double t, QPtrList<ArtBpath> &data, unsigned int i)

				kdDebug() << "SPLIT!" << endl;
			}
			else
			{
				length += 0.5 * poly + 0.5 * chord;
				i++;
			}
		}
	}

	return length;
	return 0;
}

void SVGTextPathElementImpl::pointDerivatives(double, QPtrList<ArtBpath> &, unsigned int, KSVGPoint *, KSVGPoint *, KSVGPoint *) const
{
	ArtBpath *prev = (i > 1 ? data.at(i - 1) : 0);

    if(!prev || i == 0)
        return;
	
    // Beziers.
    KSVGPoint q[4];
    q[0] = KSVGPoint(prev->x3, prev->y3);
    q[1] = KSVGPoint(data.at(i)->x1, data.at(i)->y1);
    q[2] = KSVGPoint(data.at(i)->x2, data.at(i)->y2);
    q[3] = KSVGPoint(data.at(i)->x3, data.at(i)->y3);

    // The De Casteljau algorithm.
    for(unsigned int j = 1; j <= 3; ++j)
    {
        for(unsigned int i = 0; i <= 3 - j; ++i)
            q[i] = (1.0 - t) * q[i] + t * q[i + 1];

        if(j == 1)
        {
            if(d2)
                *d2 = 6 * (q[2] - 2 * q[1] + q[0]);
        }
        else if(j == 2)
        {
            if(d1)
                *d1 = 3 * (q[1] - q[0]);
        }
    }

    if(p)
        *p = q[0];

    return;
}


void SVGTextPathElementImpl::pointTangentNormal(double, QPtrList<ArtBpath> &, unsigned int, KSVGPoint *, KSVGPoint *, KSVGPoint *) const
{
	// Calculate derivative if necessary.
  	KSVGPoint d;

	pointDerivatives(t, data, i, p, tn || n ? &d : 0);

    // Normalize derivative.
    if(tn || n)
    {
        const double norm = sqrt(d.x() * d.x() + d.y() * d.y());

		d = norm ? d * (1.0 / norm) : KSVGPoint(0.0, 0.0);
    }

    // Assign tangent vector.
    if(tn)
        *tn = d;

    // Calculate normal vector.
    if(n)
    {
        // Calculate vector product of "binormal" x tangent
        // (0,0,1) x (dx,dy,0), which is simply (dy,-dx,0).
        n->setX(d.y());
        n->setY(-d.x());
    }
}*/

void SVGTextPathElementImpl::setAttributes()
{
	SVGElementImpl::setAttributes();

	// Spec: if not specified, effect is as if a value of "0" were specified
	if(KSVG_TOKEN_NOT_PARSED(StartOffset))
		KSVG_SET_ALT_ATTRIBUTE(StartOffset, "0")

	// Spec: if not specified, effect is as if a value of "align" were specified
	if(KSVG_TOKEN_NOT_PARSED(Method))
		KSVG_SET_ALT_ATTRIBUTE(Method, "align")

	// Spec: if not specified, effect is as if a value of "exact" were specified
	if(KSVG_TOKEN_NOT_PARSED(Spacing))
		KSVG_SET_ALT_ATTRIBUTE(Spacing, "exact")
}

void SVGTextPathElementImpl::render(KSVGCanvas *)
{/*
	// Get element, referenced by xlink:href
	QString target = SVGURIReferenceImpl::getTarget(href()->baseVal().string());
	SVGPathElementImpl *other = dynamic_cast<SVGPathElementImpl *>(ownerSVGElement()->getElementById(target));

	if(!other)
		return;

	// Prepare affine
	double affine[6];
	KSVGHelper::matrixToAffine(p->worldMatrix(), affine);

	// Get text
	QString text = collectText();

	// Get font context handle
	KSVGFontContext *context = p->fontContext();
	
	// Initialize, if needed
	if(!context->initDone())
		context->init();

	// Get font
	KSVGFont *font = context->requestFont(p);
	if(!font)
		return;

	// Get resulting glyph
	GlyphLayoutParams params;
	params.tb = false;
	params.letterSpacing = params.wordSpacing = 0;
	
	KSVGGlyphSet *glyph = context->renderString(font, text, affine, params);

	if(!glyph)
		return;

	// Determine path length in arclength
	double pathLength = length(glyph->set, glyph->glyphCount);

	kdDebug() << "Path Length: " << pathLength << endl;

	float x = 0, y = 0, dx = 0,  sp = 0, fsx = 0;
	if(m_percentage)
		x = pathLength * ((1.0 / 100.0) * startOffset()->baseVal()->value());
	else
		x = pathLength * startOffset()->baseVal()->value();

	KSVGPoint point;
	KSVGPoint normal;
	KSVGPoint tangent;
	KSVGPoint extPoint;

	float yoffset = 0; //( m_position == Above ? 0 : ( m_position == On ? m_font.pointSize() / 3 : m_font.pointSize() / 1.5 ) );
	bool ext = false;
	
	for(unsigned int i = 0; i < text.length(); i++)
	{
		ArtBpath *current = glyph->set.at(i);

		// Step 1: place (0, 0) to the rotation center of the glyph.
		dx = *glyph->glyphXAdvance.at(i) / 2;
		x += dx;

		double workAffine[6];
		workAffine[0] = 1.0;
		workAffine[1] = 0.0;
		workAffine[2] = 0.0;
		workAffine[3] = 0.0;
		workAffine[4] = -dx;
		workAffine[6] = y + yoffset;
	
		ArtBpath *newPath = art_bpath_affine_transform(current, workAffine);
		if(glyph->set.replace(i, newPath)) //.at(i) = newPath;
			art_free(current);	
		current = newPath;

//		(double t, ArtBpath *prev, ArtBpath **data, unsigned int i, KSVGPoint *p, KSVGPoint *tn, KSVGPoint *n) const

		// Step 2: find the position where to draw.
		//		   3 possibilities: before, on, and after the basePath...
		if(x < 0)
		{
			if(!ext)
				pointTangentNormal(0, glyph->set, i, &extPoint, &tangent, &normal);
			point = extPoint + x * tangent;
			ext = true;
		}
		else
		{
			while(current && x > fsx + seg->length())
			{
				fsx += length(glyph->set, glyph->glyphCount);

				fsx += seg->length();
				oldSeg = seg;
				seg = ++pathIt;
			}
			if( seg )
			{
				ext = false;
				sp = ( x - fsx ) / seg->length();
				seg->pointTangentNormal( sp, &point, &tangent, &normal );
			}
			else
			{
				if( !ext )
					oldSeg->pointTangentNormal( 1, &extPoint, &tangent, &normal );
				point = extPoint + ( x - fsx ) * tangent;
				ext = true;
			}
		}
	}*/
}

// Ecma stuff

/*
@begin SVGTextPathElementImpl::s_hashTable 5
 startOffset	SVGTextPathElementImpl::StartOffset	DontDelete|ReadOnly
 method	SVGTextPathElementImpl::Method	DontDelete|ReadOnly
 spacing	SVGTextPathElementImpl::Spacing	DontDelete|ReadOnly
@end
*/

Value SVGTextPathElementImpl::getValueProperty(ExecState *exec, int token) const
{
	KSVG_CHECK_ATTRIBUTE

	switch(token)
	{
		case StartOffset:
			if(!attributeMode)
				return m_startOffset->cache(exec);
			else
				return Number(m_startOffset->baseVal()->value());
		case Method:
			if(!attributeMode)
				return m_method->cache(exec);
			else
				return Number(m_method->baseVal());
		case Spacing:
			if(!attributeMode)
				return m_spacing->cache(exec);
			else
				return Number(m_spacing->baseVal());
		default:
			kdWarning() << "Unhandled token in " << k_funcinfo << " : " << token << endl;
			return Undefined();
	}
}

void SVGTextPathElementImpl::putValueProperty(ExecState *exec, int token, const Value &value, int attr)
{
	// This class has just ReadOnly properties, only with the Internal flag set
	// it's allowed to modify those.
	if(!(attr & KJS::Internal))
		return;

	switch(token)
	{
		case StartOffset:
		{
			QString param = value.toString(exec).qstring();
			
			if(param.stripWhiteSpace().endsWith("%"))
			{
				m_percentage = true;
				param = param.mid(0, param.length() - 1);
			}
			else
				m_percentage = false;
			
			startOffset()->baseVal()->setValueAsString(param);
			break;
		}
		case Method:
		{
			QString param = value.toString(exec).qstring();

			if(param == "align")
				method()->setBaseVal(TEXTPATH_METHODTYPE_ALIGN);
			else if(param == "stretch")
				method()->setBaseVal(TEXTPATH_METHODTYPE_STRETCH);
			else
				method()->setBaseVal(TEXTPATH_METHODTYPE_UNKNOWN);

			break;
		}
		case Spacing:
		{
			QString param = value.toString(exec).qstring();

			if(param == "auto")
				spacing()->setBaseVal(TEXTPATH_SPACINGTYPE_AUTO);
			else if(param == "exact")
				spacing()->setBaseVal(TEXTPATH_SPACINGTYPE_EXACT);
			else
				spacing()->setBaseVal(TEXTPATH_SPACINGTYPE_UNKNOWN);

			break;
		}
		default:
			kdWarning() << "Unhandled token in " << k_funcinfo << " : " << token << endl;
	}
}

// CONSTANTS

/*
@begin SVGTextPathElementImplConstructor::s_hashTable 7
 TEXTPATH_METHODTYPE_UNKNOWN		KSVG::TEXTPATH_METHODTYPE_UNKNOWN	DontDelete|ReadOnly
 TEXTPATH_METHODTYPE_ALIGN	KSVG::TEXTPATH_METHODTYPE_ALIGN	DontDelete|ReadOnly
 TEXTPATH_METHODTYPE_STRETCH	KSVG::TEXTPATH_METHODTYPE_STRETCH	DontDelete|ReadOnly
 TEXTPATH_SPACINGTYPE_UNKNOWN	KSVG::TEXTPATH_SPACINGTYPE_UNKNOWN	DontDelete|ReadOnly
 TEXTPATH_SPACINGTYPE_AUTO	KSVG::TEXTPATH_SPACINGTYPE_AUTO	DontDelete|ReadOnly
 TEXTPATH_SPACINGTYPE_EXACT	KSVG::TEXTPATH_SPACINGTYPE_EXACT	DontDelete|ReadOnly
@end
*/

using namespace KJS;

Value SVGTextPathElementImplConstructor::getValueProperty(ExecState *, int token) const
{
    return Number(token);
}

Value KSVG::getSVGTextPathElementImplConstructor(ExecState *exec)
{
    return cacheGlobalBridge<SVGTextPathElementImplConstructor>(exec, "[[svgtextpathelement.constructor]]");
}

// vim:ts=4:noet
